package provide calculateMean 1.0

# Procedure to calculate the mean
proc calculateMean datalist {
	# Make variable global
	global mean
	
	# Initiate a variable to store the cumulative sum of the list
	set cumulativesum 0
	# Add each value of the list to the cumulative sum
	foreach value $datalist {
		set cumulativesum [expr {$cumulativesum + $value}]
	}
	
	# Determine the number of values in the dataset and convert to floating point
	set n [format %f [llength $datalist]]
	
	# Calculate the sample mean
	set mean [expr {$cumulativesum / $n}]
	
	# Unset variables
	unset cumulativesum n
return
}