package provide calculateMedian 1.0

# Procedure to calculate the median
proc calculateMedian datalist {
	# Make variable global so it can be accessed outside the procedure
	global median

	# Sort the datalist into numerical order
	set datalist [lsort -dictionary $datalist]
	# Determine the number of values in the dataset
	set n [llength $datalist]

	# Determine the sample statistics for an even number of values
	if {[expr {$n %2}] == 0} {
		# Determine the median as the mean of the middle two values
		set median [expr {[expr {[lindex $datalist [expr {[expr {[llength $datalist] / 2}] - 1}]] + [lindex $datalist [expr {[llength $datalist] / 2}]]}] / 2.0 }]
	# Determine the sample statistics for an odd number of values
	} elseif {[expr {$n %2}] != 0} {
		# Determine the median as the middle value of the dataset
		set median [lindex $datalist [expr {int([expr {floor([expr {[llength $datalist] / 2.0}])}])}]]
	}
	# Unset variables so they can't be reused
	unset datalist n
return
}